unit TestStyle;

interface
uses Classes, RVStyle;

type
  TFontStyleEx = (fsShadow, fsOutline);
  TFontStylesEx = set of TFontStyleEx;

  TFontInfoEx = class (TFontInfo)
    private
      FMoreStyles: TFontStylesEx;
    public
      procedure Assign(Source: TPersistent); override;
    published
      property MoreStyles: TFontStylesEx read FMoreStyles write FMoreStyles default [];
  end;


  TRVStyleEx = class (TRVStyle)
    public
      function GetTextStyleClass: TRVFontInfoClass; override;
  end;

procedure Register;


implementation

{ TTestRVStyle }

function TRVStyleEx.GetTextStyleClass: TRVFontInfoClass;
begin
  Result := TFontInfoEx;
end;

{ TFontInfoEx }

procedure TFontInfoEx.Assign(Source: TPersistent);
begin
  if Source is TFontInfoEx then begin
    MoreStyles := TFontInfoEx(Source).MoreStyles;
  end;
  inherited;
end;

procedure Register;
begin
  RegisterComponents('RichView', [TRVStyleEx]);
end;

end.
