unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVScroll, RichView, RVEdit, RVStyle, TestStyle;

type
  TForm1 = class(TForm)
    RVStyleEx1: TRVStyleEx;
    RichViewEdit1: TRichViewEdit;
    procedure RVStyleEx1DrawStyleText(Sender: TRVStyle; const s: String;
      Canvas: TCanvas; StyleNo, SpaceBefore, Left, Top, Width,
      Height: Integer; DrawState: TRVTextDrawStates;
      var DoDefault: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.RVStyleEx1DrawStyleText(Sender: TRVStyle; const s: String;
  Canvas: TCanvas; StyleNo, SpaceBefore, Left, Top, Width, Height: Integer;
  DrawState: TRVTextDrawStates; var DoDefault: Boolean);
var Shadow, Outline: Boolean;
  OnePixel, ShadowOffs: Integer;
  Color: TColor;
begin
  {
   Limitations:
   - effects will not be visible on colored background
     (solution: draw all text yourself, including background, and turn off
      default drawing)
   - Unicode is not supported
     (solution: use TextOutW for Unicode text)
  }
  Shadow := fsShadow in TFontInfoEx(Sender.TextStyles[StyleNo]).MoreStyles;
  Outline := fsOutline in TFontInfoEx(Sender.TextStyles[StyleNo]).MoreStyles;
  OnePixel := Canvas.Font.PixelsPerInch div 96; // for printing it can be greater than 1
  if Shadow then begin
    ShadowOffs := OnePixel;
    if Outline then
      inc(ShadowOffs, OnePixel);
    Color := Canvas.Font.Color;
    Canvas.Font.Color := clBtnShadow;
    Canvas.TextOut(Left+SpaceBefore+ShadowOffs, Top+ShadowOffs, s);
    Canvas.Font.Color := Color;
  end;
  if Outline then begin
    Canvas.TextOut(Left+SpaceBefore+OnePixel, Top+OnePixel, s);
    Canvas.TextOut(Left+SpaceBefore-OnePixel, Top-OnePixel, s);
    Canvas.TextOut(Left+SpaceBefore+OnePixel, Top-OnePixel, s);
    Canvas.TextOut(Left+SpaceBefore-OnePixel, Top+OnePixel, s);
    Canvas.Font.Color := clWhite;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNL('aaaaaaaaaaaaaaaaaaaa',0,0);
  RichViewEdit1.AddNL('aaaaaaaaaaaaaaaaaaaa',1,0);
  RichViewEdit1.AddNL('aaaaaaaaaaaaaaaaaaaa',2,0);
  RichViewEdit1.AddNL('aaaaaaaaaaaaaaaaaaaa',3,0);  
  RichViewEdit1.Format;      
end;

end.
 